// cc-by 3.0 Austria, (c) 2010 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/

// Declare Sequences
println("----------Declare Sequences----------");

var strings: String[] = ["Hello", "Sequence"];
println(strings);

var strings2 : String[] = [strings, "!"];
println(strings2);

var strings3 : String[] = [["A"],[["B"],["C"]],["D"]];
print(strings3); println(" size: {sizeof strings3}");

var strings4 : String[] = "Hello";
println(strings4);


// Manipulate Sequences
println("----------Manipulate Sequences----------");


var numbers : Integer[] = [5];
println(numbers);

insert 1 into numbers;
println(numbers);

insert [6..9] into numbers;
println(numbers);

delete 5 from numbers;
println(numbers);

delete numbers[sizeof numbers - 1];
println(numbers);

insert 5 after numbers[4];
println(numbers);

insert [2..5] before numbers[1];
println(numbers);

numbers = reverse numbers;
println(numbers);


// Subsequences
println("----------Subsequences----------");


numbers = [5..9];
println(numbers);

var part : Integer[];

part = numbers[1..3];
println(part);

part = numbers[x | x > 7];
println(part);

part = numbers[x | x > 5 and (x mod 2 == 0)];
println(part);

numbers[0..-1] = [0,1,2,3,4];
println(numbers);

numbers[7..] = null;
println(numbers);

numbers[4..5] = [10, 11, 12];
println(numbers);


// For Sequences
println("----------For Sequences----------");

numbers = for (x in [1..5]) x * x;
println(numbers);

var names : String[] = ["Jane", "Mike", "Betty", "Frank"];
println(numbers);

var comb : String[] = for (name in names, nr in numbers where nr mod 2 == 0) "{name}:{nr}";
println(comb);


// Util Sequences
println("----------Util Sequences----------");


names = ["Abel", "Betty", "Cesar", "Debby", "Emil", "Frank"];
println(names);

println("binarySearch Emil: {javafx.util.Sequences.binarySearch(names, "Emil")}");

names = javafx.util.Sequences.shuffle(names) as String[];
println(names);
println("binarySearch Emil: {javafx.util.Sequences.binarySearch(names, "Emil")}");
println("indexOf Emil: {javafx.util.Sequences.indexOf(names, "Emil")}");

println("max: {javafx.util.Sequences.max(names)}");
println("min: {javafx.util.Sequences.min(names)}");

println(javafx.util.Sequences.sort(names));